{ ****************************************************************************
    Copyright (c) 2015 by Michael Van Canneyt

    Pascal version of Skeleton Android application. Visual part
  ****************************************************************************}

unit skeletonapp;

{$mode objfpc}{$H+}
{$namespace eu.blaisepascal.skeletonapp}
{$modeswitch unicodestrings}

interface

uses
  androidr14, resources;

type

  { TSkeletonActivity }
  TSkeletonActivity = class(AAActivity,AWButton.InnerOnClickListener)
  protected
    FEditor : AWEditText;
    FClear : AWButton;
    FBack : AWButton;
    FBackID : Integer;
    FClearID : Integer;
  public
    procedure onCreate(savedInstanceState: AOBundle); override;
    Function onCreateOptionsMenu(AMenu : AVMenu) :  boolean ; override;
    Function onPrepareOptionsMenu(AMenu : AVMenu) : Boolean; override;
    Function onOptionsItemSelected(AItem : AVMenuItem) : Boolean; override;
    Procedure onClick(v : AVView); // OnClick
  end;

implementation

function TSkeletonActivity.onCreateOptionsMenu(AMenu : AVMenu) :  boolean;

begin
  inherited;
  AMenu.add(0,AVMenu.FIRST,0,R.strings.back).setShortcut('0','b');
  AMenu.add(0,AVMenu.FIRST+1,0,R.strings.clear).setShortcut('1','c');
  Result:=True;
end;

Function TSkeletonActivity.onPrepareOptionsMenu(AMenu : AVMenu) : Boolean;

begin
  Inherited;
  AMenu.findItem(AVMenu.FIRST+1).setVisible(FEditor.getText().length()>0);
  Result:=True;
end;

Function TSkeletonActivity.onOptionsItemSelected(AItem : AVMenuItem) : Boolean;

begin
  Case AItem.getItemId() of
  AVMenu.First:
    begin
    finish();
    Exit(true);
    end;
  AVMenu.First+1:
    begin
    FEditor.setText(JLString(''));
    Exit(true);
    end
  else
    Result:=Inherited onOptionsItemSelected(AItem);
  end;
end;

Procedure TSkeletonActivity.onClick(v : AVView); // OnClick interface
begin
  if (V=Fback) then
    Finish
  else if (V=FClear) then
    FEditor.SetText(JLString(''));
end;

procedure TSkeletonActivity.onCreate(savedInstanceState: AOBundle);

begin
  inherited;
  setContentView(R.layout.skeleton_activity);
  FEditor:=AWEditText(findViewById(R.id.editor));
  FBack:=AWButton(findViewById(R.id.back));
  FBack.setOnClickListener(Self As AWButton.InnerOnClickListener);
  FClear:=AWButton(findViewById(R.id.clear));
  FClear.setOnClickListener(Self As AWButton.InnerOnClickListener);
  FEditor.setText(getText(R.strings.Hello));
end;

end.

